/*======================================================================================
   format_plugin_sample.c
======================================================================================
 $RCSfile: format_plugin_sample.c$
 $Revision:$
 $Date:$
 $Author:Will Huang$
 $Revision: $
======================================================================================

======================================================================================


---------------------------------------------------------------------------

  Module Description:
     Format Plugin sample.

---------------------------------------------------------------------------*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#include "hsm_plugin/matrix_barcodeid.h"
#include "hsm_plugin/matrix_plugin.h"
#include "hsm_plugin/matrix_format_plugin.h"
#include "hsm_plugin/matrix_beep_led.h"
#include "hsm_plugin/matrix_syscalls.h"
/*===================================================================
 * Plug-in properties
 * Defined by user
 *
=====================================================================*/
#define PLUGIN_NAME SampleFormat
#define COMPANY_NAME Plug-In Developer, Inc.
#define MAJOR_VERSION	5
#define MONOR_VERSION	3
#define BUILD_NUMBER	37
#define CERTIFICATE		102148
#define CERTIFICATE_TIME	2009/08/10 15:00:05
#define PLUGIN_GUID	abcd1234
#define FILE_NAME		Format.plugin

#define MenuID	0xA0020

static int  Licensed;
static int Initial_enable_me=1;
static int  Enable_me=1;
static int LEDDurationVaild=1;
static int BEEPDurationValid=1;


static int LEDDurationTime=1000;
static int BeepDurationTime=1000;
static int LEDEnable=0;

const unsigned int PluginGoodReadBeepSeq1000ms[]=	{2,1000,3250,500,0,0x00};
const unsigned int PluginGoodReadBeepSeq1250ms[]=	{2,1250,3250,500,0,0x00};
const unsigned int PluginGoodReadBeepSeq1500ms[]=	{2,1500,3250,500,0,0x00};
const unsigned int PluginGoodReadBeepSeq1750ms[]=	{2,1750,3250,500,0,0x00};
const unsigned int PluginGoodReadBeepSeq2000ms[]=	{2,2000,3250,500,0,0x00};
const unsigned int PluginGoodReadBeepSeq2250ms[]=	{2,2250,3250,500,0,0x00};
const unsigned int PluginGoodReadBeepSeq2500ms[]=	{2,2500,3250,500,0,0x00};
const unsigned int PluginGoodReadBeepSeq2750ms[]=	{2,2750,3250,500,0,0x00};
const unsigned int PluginGoodReadBeepSeq3000ms[]=	{2,3000,3250,500,0,0x00};
const unsigned int PluginGoodReadBeepSeq3250ms[]=	{2,3250,3250,500,0,0x00};
const unsigned int PluginGoodReadBeepSeq3500ms[]=	{2,3500,3250,500,0,0x00};
const unsigned int PluginGoodReadBeepSeq3750ms[]=	{2,3750,3250,500,0,0x00};
const unsigned int PluginGoodReadBeepSeq4000ms[]=	{2,4000,3250,500,0,0x00};


//Blink Timer

int m_StartTickForLED = 0;
int m_TickDurationLED = 0;
int m_StartTickForIll = 0;
int m_TickDurationIll = 0;


void TimerSetExpirationForLED(int mSec )
{
	m_StartTickForLED = decoder_mstimer();
	m_TickDurationLED = mSec;
}

int TimerHasExpiredForLED(void)
{
	int nDiff = decoder_mstimer() - m_StartTickForLED;
	return (nDiff >= m_TickDurationLED);
}


void TimerSetExpirationForIllumination(int mSec )
{
	m_StartTickForIll = decoder_mstimer();
	m_TickDurationIll = mSec;
}

int TimerHasExpiredForIllumination(void)
{
	int nDiff = decoder_mstimer() - m_StartTickForIll;
	return (nDiff >= m_TickDurationIll);
}



/** ConvertMenuData
 * Takes Chars from the input string and converts them to HEX Data
 *  pMenuData pointer to input string 
 *  StartIndex starting index the nex three char will be converted
 *  returns int made up of all three input chars
 */
int ConvertMenuData(char *pMenuData, int StartIndex)
{
		int Char1 = 0, Char2 = 0, Char3 = 0, Char4=0;
	
		
			Char1 = (pMenuData[StartIndex] - 0x30);
				
			Char2 = (pMenuData[StartIndex + 1] - 0x30);		

			Char3 = (pMenuData[StartIndex + 2] - 0x30);

			Char4 = (pMenuData[StartIndex + 3] - 0x30);
	
		return (Char1*1000+Char2*100+Char3*10+Char4);		//Add them together
}



/** This API is called to perform a data fromat.
 *  The plug-in developer should implement this
 *  routine by himself and set address of this 
 *  function to the "DataEdit" field of the 
 *  "DataEditApi" sturture.
 */
int MatrixPluginDataEdit(DataEditParam *pFormatParam)
{
	// Add your Format code here and copy the result back to pFormatParam->message.
	printf("\r\nMatrixPluginDataEdit\r\n");
	if((pFormatParam->HHPcodeID!=156)&&(pFormatParam->AIMcodeLetter!=0)&&(pFormatParam->AIMcodeModifier !=0))
	{
		FILE *fpforBeep=NULL; 
		
		fpforBeep= fopen ("BeepDuration", "r");
		if(fpforBeep == NULL)
		{
			printf("MatrixPluginDataEdit: UseInitialBeepDuration\r\n");
		}
		else
		{

				int tmp;
				fseek(fpforBeep, 0, SEEK_SET);
				tmp=fread(&BeepDurationTime, 1, 4, fpforBeep);
				printf("fread BeepDuration %d \r\n", BeepDurationTime);			
				fclose(fpforBeep);
			
		}
		
		FILE *fpforLED=NULL; 
		fpforLED= fopen ("LEDDuration", "r");
		
		if(fpforLED == NULL)
		{
			printf("MatrixPluginDataEdit: UseInitialLEDDuration\r\n");
			
		}
		else
		{
				int tmp;
				fseek(fpforLED, 0, SEEK_SET);
				tmp=fread(&LEDDurationTime, 1, 4, fpforLED);
				printf("fread LEDDuration %d \r\n", LEDDurationTime);		
				fclose(fpforLED);
				
		}
		LEDEnable=1;
		plugin_io_init(0x040, 0x040);   //initial the GPIO
		plugin_io_write(0x040, 0x000);  //Trun on Led and Beep
		TimerSetExpirationForLED(LEDDurationTime);
		if (BeepDurationTime>=1000&&BeepDurationTime<1125)
		beep_led_io(PluginGoodReadBeepSeq1000ms, 6);
		else if (BeepDurationTime>=1125&&BeepDurationTime<1375)
		beep_led_io(PluginGoodReadBeepSeq1250ms, 6);
		else if (BeepDurationTime>=1375&&BeepDurationTime<1625)
		beep_led_io(PluginGoodReadBeepSeq1500ms, 6);
		else if (BeepDurationTime>=1625&&BeepDurationTime<1875)
		beep_led_io(PluginGoodReadBeepSeq1750ms, 6);
		else if (BeepDurationTime>=1875&&BeepDurationTime<2125)
		beep_led_io(PluginGoodReadBeepSeq2000ms, 6);
		else if (BeepDurationTime>=2125&&BeepDurationTime<2375)
		beep_led_io(PluginGoodReadBeepSeq2250ms, 6);
		else if (BeepDurationTime>=2375&&BeepDurationTime<2625)
		beep_led_io(PluginGoodReadBeepSeq2500ms, 6);
		else if (BeepDurationTime>=2625&&BeepDurationTime<2875)
		beep_led_io(PluginGoodReadBeepSeq2750ms, 6);
		else if (BeepDurationTime>=2875&&BeepDurationTime<3125)
		beep_led_io(PluginGoodReadBeepSeq3000ms, 6);
		else if (BeepDurationTime>=3125&&BeepDurationTime<3375)
		beep_led_io(PluginGoodReadBeepSeq3250ms, 6);
		else if (BeepDurationTime>=3375&&BeepDurationTime<3625)
		beep_led_io(PluginGoodReadBeepSeq3500ms, 6);
		else if (BeepDurationTime>=3625&&BeepDurationTime<3875)
		beep_led_io(PluginGoodReadBeepSeq3750ms, 6);
		else if (BeepDurationTime>=3875&&BeepDurationTime<=4000)
		beep_led_io(PluginGoodReadBeepSeq4000ms, 6);
				
	}
	return 0;
}

/** This API is called to perform polled tasks.
 *  The plug-in developer should implement this
 *  routine by himself.
 */
void MatrixPluginPollingFunction(void)
{
	// Add your Polling code here

			
	if(LEDEnable&&TimerHasExpiredForLED())
	{	
	     	LEDEnable=0;
		plugin_io_write(0x040, 0x040);//turn off LED 
		
	}

	
}



/** This API is called when plug-in needs to configure itself by 
 *  scanning a specific menu barcode.
 *  Specific Menu Data is used to control the GPIO
 *  B - indicate setting BEEP duration for example B4000 menas set beep on duration time is 4000ms.
 *  L the same as B

 */
int MatrixPluginProcessingBarcode(char *pMenuData, int DataLength)
{
	// Add your plugin menu processing code here and return 0 if succeed and -1 if fail, 
	// system will beeps error or success according to the return value

	if ( DataLength == 5 && ((pMenuData[0] == 'L')||(pMenuData[0] == 'l') ))
	{
 		LEDDurationTime = ConvertMenuData(pMenuData, 1);
		LEDDurationVaild=1;
		if(LEDDurationTime>4000)
		{	
			printf("Set LED Polling Duration Time is bigger than the max value, use the default value 1000ms \r\n");
			LEDDurationTime=1000;
			LEDDurationVaild=0;
		}
		
		printf("Set LED Polling Duration Time %d \r\n",LEDDurationTime);
		FILE *fpforLED=NULL;
		fpforLED= fopen ("LEDDuration", "w");
		if(fpforLED == NULL)
		{
			printf("fopen LEDDuration,failed\r\n");
			return -1;
		}
		else
		{
			int tmp;
			fseek(fpforLED, 0, SEEK_SET);
			tmp=fwrite(&LEDDurationTime, 1, 4, fpforLED);
			if(tmp==0)
			{
				printf("MatrixPluginProcessingBarcode: fwrite LEDDuration,failed\r\n");
				fclose(fpforLED);
				return -1;
			}
			else
			{
				printf("fwrite LEDDuration %d ms\r\n", LEDDurationTime);			
				fclose(fpforLED);
				if(LEDDurationVaild==0)
					return -1;
				else 
				{
					LEDDurationVaild=1;
					return 0;
				}
			}
		}
		
		
	}
	else if ( (DataLength < 5 ||DataLength >5)&& (((pMenuData[0] == 'L')||(pMenuData[0] == 'l') )))
	{
		if (DataLength < 5)
			printf("Set LED Polling Duration Time smaller than the min value, use the default value 1000ms \r\n");
		else if (DataLength >5) 
			printf("Set LED Polling Duration Time is bigger than the max value, use the default value 1000ms \r\n");
		LEDDurationTime=1000;
		printf("Set LED Polling Duration Time %d \r\n",LEDDurationTime);
		FILE *fpforLED=NULL;
		fpforLED= fopen ("LEDDuration", "w");
		if(fpforLED == NULL)
		{
			printf("fopen LEDDuration,failed\r\n");
			return -1;
		}
		else
		{
			int tmp;
			fseek(fpforLED, 0, SEEK_SET);
			tmp=fwrite(&LEDDurationTime, 1, 4, fpforLED);
			if(tmp==0)
			{
				printf("MatrixPluginProcessingBarcode: fwrite LEDDuration,failed\r\n");
				fclose(fpforLED);
				return -1;
			}
			else
			{
				printf("fwrite LEDDuration %d ms\r\n", LEDDurationTime);			
				fclose(fpforLED);
			}
		}
			
	}
	if ( DataLength == 5 && ((pMenuData[0] == 'B')||(pMenuData[0] == 'b')) )
	{
		BeepDurationTime= ConvertMenuData(pMenuData, 1);
		BEEPDurationValid=1;
		if(BeepDurationTime>4000)
		{
			printf("Set Beep Duration Time is bigger than max value, use the default value 1000ms\r\n");
			BeepDurationTime=1000;
			BEEPDurationValid=0;
		}
		printf("Set Beep Duration Time %d \r\n",BeepDurationTime);
		
		FILE *fpforBeep=NULL;
		fpforBeep= fopen ("BeepDuration", "w");
		if(fpforBeep == NULL)
		{
			printf("fopen BeepDuration,failed\r\n");
			return -1;
		}
		else
		{
			int tmp;
			fseek(fpforBeep, 0, SEEK_SET);
			tmp=fwrite(&BeepDurationTime, 1, 4, fpforBeep);
			if(tmp==0)
			{
				printf("MatrixPluginProcessingBarcode: fwrite BeepDuration,failed\r\n");
				fclose(fpforBeep);
				return -1;
			}
			else
			{
				printf("fwrite BeepDuration %d ms\r\n", BeepDurationTime);			
				fclose(fpforBeep);
				if(BEEPDurationValid==0)
					return -1;
				else 
				{
					BEEPDurationValid=1;
					return 0;
				}
			}
		}

	}
	else if (( DataLength < 5||DataLength >5) && (((pMenuData[0] == 'B')||(pMenuData[0] == 'b')) ))	
	{
		if (DataLength<5)
			printf("Set Beep Duration Time is smaller than min value, use the default value 1000ms\r\n");
		else if (DataLength>5)
			printf("Set Beep Duration Time is bigger than max value, use the default value 1000ms\r\n");
		
		BeepDurationTime=1000;
		printf("Set Beep Duration Time %d \r\n",BeepDurationTime);
		FILE *fpforBeep=NULL;
		fpforBeep= fopen ("BeepDuration", "w");
		if(fpforBeep == NULL)
		{
			printf("fopen BeepDuration,failed\r\n");
			return -1;
		}
		else
		{
			int tmp;
			fseek(fpforBeep, 0, SEEK_SET);
			tmp=fwrite(&BeepDurationTime, 1, 4, fpforBeep);
			if(tmp==0)
			{
				printf("MatrixPluginProcessingBarcode: fwrite BeepDuration,failed\r\n");
				fclose(fpforBeep);
				return -1;
			}
			else
			{
				printf("fwrite BeepDuration %d ms\r\n", BeepDurationTime);			
				fclose(fpforBeep);
			}
		}

	}
	return -1;
}

/** The MatrixPlulginCheckLicense API is used to validate if 
 *  the plug-in is licensed or not. This function will be called
 *  immediately when the plug-in is loaded. Plug-in should keep
 *  the result of the license validation during its runtime.If 
 *  the plug-in is not licensed, the plug-in must return -1 when
 *  any other API of it is called.
 */
int MatrixPlulginCheckLicense(char *SN)
{
	// Add your license validation code here
	// return 0 to indicate the plug-in is licensed
	// return -1 for not licensed
	printf("\r\nMatrixPlulginCheckLicense\r\n");
	printf("Serial Number: %s\r\n", SN);
	return 0;
}


/** Honeywell Gen.6 scanner use this API to retrieve plug-in
 *  Version information. The version information will be filled
 *  in the VersionInfo structure after the API returns
 *  successfully.
 */
int MatrixPluginGetVersion(VersionInfo *pInfo)
{
	// Add your Get version code here
	// Plugin should fill in the pInfo
	// with the plugin version info
	// return 0 for success and -1 for failure
	printf("\r\nMatrixPluginGetVersion\r\n");
	return 0;
}

/********************************************** 
   Format Plugin APIs definition 
   Fill the fields with 
   user defined APIs.
 *********************************************/
static DataEditApi apis = {
	.RevisionNumber = 2,
	.DataEdit = MatrixPluginDataEdit,
	.ProcessingBarcode = MatrixPluginProcessingBarcode,
	.CheckLicense = MatrixPlulginCheckLicense,
	.GetVersion = MatrixPluginGetVersion,
	.GPIO_Plugins = MatrixPluginPollingFunction,
};


/**********************************************
   This is the initial function of plug-in
   This routine is user defined and be used
   to initilize plug-in and register plug-in
   APIs.
   Parameter:
   		plugin ---- Plug-in information structure
   Return Value:
   		-1 indicate a error and 0 to success
 *********************************************/
int init_plugin(HONPluginRawInfo *plugin)
{
	int ret = 0;
	
	printf("/******************************/\r\n");
	printf("     Sample Format Plugin with GPIO Control\r\n");
	printf("/******************************/\r\n");
	
	ret = register_apis(plugin, &apis);
	if(ret){
		printf("Plugin APIs Registration Failed\r\n");
		return -1;
	}
	
	return 0;

}

/**********************************************
   This is the cleanup function of plug-in
   This routine is user defined and is used
   to cleanup plug-in when remove plug-in from
   system.
 *********************************************/
void cleanup_plugin(void)
{
	return;
}

/**********************************************
   We should declare the plug-in by using
   'DECLARE_PLUGIN' macro in order that 
   Matrix can recognize the plug-in
 *********************************************/
DECLARE_PLUGIN(init_plugin, cleanup_plugin, HON_PLUGIN_FORMAT, MenuID);

/*=================================================================================
                       File Modification History
===================================================================================
 $Log:$
===================================================================================*/


