/*======================================================================================
   format_plugin_sample2.c
======================================================================================
 $RCSfile: format_plugin_sample2.c$
 $Revision:$
 $Date:$
 $Author:Will Huang$
 $Revision: $
======================================================================================

======================================================================================


---------------------------------------------------------------------------

  Module Description:
     Format Plugin sample.

---------------------------------------------------------------------------*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#include <hsm_plugin/matrix_barcodeid.h>
#include <hsm_plugin/matrix_plugin.h>
#include <hsm_plugin/matrix_format_plugin.h>
#include <hsm_plugin/matrix_beep_led.h>

/*===================================================================
 * Plug-in properties
 * Defined by user
 *
=====================================================================*/
#define PLUGIN_NAME EasyUSPS2
#define COMPANY_NAME Plug-In Developer, Inc.
#define MAJOR_VERSION	1
#define MONOR_VERSION	1
#define BUILD_NUMBER	1
#define CERTIFICATE		100000
#define CERTIFICATE_TIME	2011/03/11 09:57:00
#define PLUGIN_GUID	abcd1234
#define FILE_NAME		EasyUSPS2.plugin

#define MenuID	0xF0020
extern int HelloWorld(void);
static int  Licensed;
static int Initial_enable_me=1;
static int  Enable_me=1;
static int progmd=0;
// maximum barcode length is 254
// maximum length after Base64 is 342
// plus code type, ',' and <stx>, <etx>, the maxi totally length is 346
#define MAX_TATS_BC_LEN            256
#define MAX_TATS_BF_SIZE           342       // Barcode buffer size in chars for TATS 


/************************************************************************/
// Get the USPS defined barcode identifier
/*************************************************************************/




/************************************************************************/
// Base64 converstion function
/*************************************************************************/




int MatrixPluginDataEdit(DataEditParam *pFormatParam)
{	
	beep_led_io(MenuDifferentBeepSeq, 6);
	return 0;
}

/** This API is called when plug-in needs to configure itself by 
 *  scanning a specific menu barcode.
 */
int MatrixPluginProcessingBarcode(char *pMenuData, int DataLength)
{
	// Add your plugin menu processing code here and return 0 if succeed and -1 if fail, 
	// system will beeps error or success according to the return value
	printf("\r\nMatrixPluginProcessingBarcode\r\n");
	printf("Menu Data is: ");
	printf(pMenuData);
	printf("\r\n");
	
	FILE *fp=NULL; 
	if ( DataLength >= 2 && strncmp((char*)pMenuData, "00", 2) == 0 )
	{
		Enable_me = 0;
		beep_led_io(MenuDifferentBeepSeq, 6);
		progmd=1;
	}
	if ( DataLength >= 2 && strncmp((char*)pMenuData, "01", 2) == 0 )
	{
		Enable_me = 1;
		beep_led_io(MenuDifferentBeepSeq, 6);
		progmd=1;
	}
	if ( DataLength >= 2 && strncmp((char*)pMenuData, "02", 2) == 0 )
	{
		HelloWorld();
		beep_led_io(MenuDifferentBeepSeq, 6);
		return 0;
		
	}
	if(progmd==1)
	{
		fp= fopen ("PluginEnable", "w");
		if(fp == NULL)
		{
			printf("fopen PluginEnable,failed\r\n");
			return -1;
		}
		else
		{
			int tmp;
			fseek(fp, 0, SEEK_SET);
			tmp=fwrite(&Enable_me, 1, 1, fp);
			if(tmp==0)
			{
				printf("MatrixPluginProcessingBarcode: fwrite PluginEnable,failed\r\n");
				fclose(fp);
				return -1;
			}
			else
			{
				printf("fwrite PluginEnable %d byte\r\n", tmp);			
				fclose(fp);
				return 0;
			}
		}

	}


	return -1;
}

/** The MatrixPlulginCheckLicense API is used to validate if 
 *  the plug-in is licensed or not. This function will be called
 *  immediately when the plug-in is loaded. Plug-in should keep
 *  the result of the license validation during its runtime.If 
 *  the plug-in is not licensed, the plug-in must return -1 when
 *  any other API of it is called.
 */
int MatrixPlulginCheckLicense(char *SN)
{
	// Add your license validation code here
	// return 0 to indicate the plug-in is licensed
	// return -1 for not licensed
	printf("\r\nMatrixPlulginCheckLicense\r\n");
	printf("Serial Number: %s\r\n", SN);
	return 0;
}


/** Honeywell Gen.6 scanner use this API to retrieve plug-in
 *  Version information. The version information will be filled
 *  in the VersionInfo structure after the API returns
 *  successfully.
 */
int MatrixPluginGetVersion(VersionInfo *pInfo)
{
	// Add your Get version code here
	// Plugin should fill in the pInfo
	// with the plugin version info
	// return 0 for success and -1 for failure
	printf("\r\nMatrixPluginGetVersion\r\n");
	return 0;
}

void MatrixPluginGPIO_Plugins()
{
	DataEditApi apis;
//	apis.RevisionNumber=3;
//	printf("\r\nMatrixPluginNewfunction\r\n");

}

/********************************************** 
   Format Plugin APIs definition 
   Fill the fields with 
   user defined APIs.
 *********************************************/
static DataEditApi apis = {
	.RevisionNumber = 1,
	.DataEdit = MatrixPluginDataEdit,
	.ProcessingBarcode = MatrixPluginProcessingBarcode,
	.CheckLicense = MatrixPlulginCheckLicense,
	.GetVersion = MatrixPluginGetVersion,
 //      .GPIO_Plugins=MatrixPluginGPIO_Plugins,
	//.Newfunction=MatrixPluginNewfunction,
};


/**********************************************
   This is the initial function of plug-in
   This routine is user defined and be used
   to initilize plug-in and register plug-in
   APIs.
   Parameter:
   		plugin ---- Plug-in information structure
   Return Value:
   		-1 indicate a error and 0 to success
 *********************************************/
int init_plugin(HONPluginRawInfo *plugin)
{
	int ret = 0;
	FILE* file = NULL;
	void *pTest = NULL;
	
	printf("/******************************/\r\n");
	printf("     Sample Format Plugin \r\n");
	printf("/******************************/\r\n");
	
	


	printf("Before malloc\r\n");
	pTest = malloc(1);
	printf("after malloc\r\n");
	
	if(!pTest)
		printf("malloc fail\r\n");
	else{
		printf("malloc ok\r\n");
		free(pTest);
	}
	
	pTest = calloc(1, 10);
	if(!pTest)
		printf("calloc fail\r\n");
	else{
		printf("calloc ok\r\n");
		free(pTest);
	}
	
	file = fopen("format_cfg", "r");
	if(file){
		int r;
		printf("close file\r\n");
		r = fclose(file);
		printf("close return is %d\r\n");
	}
		unlink("format_cfg");
#if 0		
	file = fopen("format_cfg", "r");
	if(!file){
		file = fopen("format_cfg", "w");
		if (file)
		{
			printf("Open okay\r\n");
			if(fwrite("[0&1/d0/s,/f12/f13/f14/", 1, 24, file) == 24){
				printf("Write okay\r\n");
			}
			fclose(file);
		}else{
			printf("Open failed\r\n");
		}
	}


	file = fopen("format_cfg", "r");
	if (file)
	{
		char buf[32];
		int rt = 0;
		rt = fread(buf, 1, 24, file);
		printf("Read return value is %d\r\n", rt);
		if(rt == 24){
			buf[24] = 0;
			printf("Read ok\r\n");
			printf("buf is %s", buf);
		}else
			printf("Read fail\r\n");
		fclose(file);
	}else{
		printf("Open read failed\r\n");
	}
#endif	

	
	ret = register_apis(plugin, &apis);
	if(ret){
		printf("Plugin APIs Registration Failed\r\n");
		return -1;
	}
	
	return 0;

}

/**********************************************
   This is the cleanup function of plug-in
   This routine is user defined and is used
   to cleanup plug-in when remove plug-in from
   system.
 *********************************************/
void cleanup_plugin(void)
{
	return;
}

/**********************************************
   We should declare the plug-in by using
   'DECLARE_PLUGIN' macro in order that 
   Matrix can recognize the plug-in
 *********************************************/
DECLARE_PLUGIN(init_plugin, cleanup_plugin, HON_PLUGIN_FORMAT, MenuID);

/*=================================================================================
                       File Modification History
===================================================================================
 $Log:$
===================================================================================*/


